<?php
/*
	List plugins lists all active plugins and presents functions they offer. It creates
	unordered (possibly nested) list of plugins and their functions.
	
	It is activated by ?action=listplugins
*/

class PageVersions
{
  public $desc = array(
		array("ArticleVersions", "provides list of language versions of current article. Displayerd using {VERSIONS}.")
	);
	
	public $default_lang = "en"; // what language is it if no lang code is given?

	public $lang_names = array(
		"bg" => "Български",
		"ca" => "Català",
		"cs" => "Čeština",
		"de" => "Deutsch",
		"da" => "Dansk",
		"en" => "English",
		"es" => "Español",
		"fi" => "Eesti",
		"fr" => "Français",
		"hr" => "Hrvatski",
		"hu" => "Magyar",
		"nl" => "Nederlands",
		"pl" => "Polski",
		"pt" => "Português",
		"ro" => "Română",
		"ru" => "Русский",
		"sk" => "Slovenština",
		"sv" => "Svenska"
	);

	function template()
	{
	  global $CON, $page, $PAGES_DIR;
	  
	  if(strpos($CON, "{VERSIONS}") === false)
	  	return true;
	  
	  if(($pos = strpos($page, ".")) !== false)
	  	$p = preg_quote(substr($page, 0, $pos));
	  else
	  	$p = preg_quote($page);
	  	
	  $versions = array();
	  
	  if($dir = @opendir($PAGES_DIR))
			while($file = readdir($dir))
				if(preg_match("/$p\.([a-z]+)\.txt|$p\.txt/", $file, $match))
					$versions[isset($match[1]) ? $match[1] : $this->default_lang] = $match[0];
					
		ksort($versions);
		
		$list = "<ul class=\"subpage\">\n";
		
		foreach($versions as $code => $art)
			$list .= "  <li><a href=\"?page=".urlencode(trim($art, ".txt"))."\">".$this->lang_names[$code]."</a></li>\n";
		
		$list .= "</ul>\n";
		
		$CON = str_replace("{VERSIONS}", $list, $CON);
	}
}
?>
