<?php
/** File upload plugin for Wikiss, adjusted and slightly improved for LionWiki
 * access with : ?action=upload
 */

class Upload
{
  /** Check/corect path validity
   * remove .., ^/, //, /$ and decode path
   * input: path
   * return corrected path
   */
  
  public $desc = array(
		array("<a href=\"?action=upload\">Upload plugin</a>", "provides uploading files to the server.")
	);
	
	public $datadir;
	
	public $blacklist = array(".php", ".phtml", ".php3", ".php4", ".js", ".shtml", ".pl" ,".py", ".asp", ".jsp", ".sh", ".cgi"); // forbidden file extensions

  function __construct()
  {
  	global $BASE_DIR;
  
  	$this->datadir = $BASE_DIR . "data/";
  
    $this->localize();
  }

  function cleanInput($input)
  {
    return trim(preg_replace('/(\.\.|^\/|\/\/)/', '', urldecode($input)), '/');
  }

  function action($action)
  {
    global $CON, $TITLE, $editable, $T_PASSWORD, $TE_WRONG_PASSWORD, $error;

    $curdir = "";

    if($action == "upload") {
      $CON = "";
      
      $TITLE = $this->TP_FILE_UPLOAD;

      if(is_dir($this->datadir)) {
        $curdir = $this->cleanInput($_REQUEST['curdir']);

        if(!preg_match('/^' . preg_quote(trim($this->datadir, "/"), "/") . "/", $curdir)) // curdir must be data dir subdirectory
          $curdir = trim($this->datadir, '/');

        if(authentified()) {
          if(!empty($_POST['dir2create']))
            @mkdir($curdir . '/' . $this->cleanInput($_POST['dir2create']));
          elseif(!empty($_FILES['file']['tmp_name'])) { // anything to upload?
            if(is_uploaded_file($_FILES['file']['tmp_name'])) {
							foreach($this->blacklist as $file) // executable files not allowed
								if(preg_match("/" . preg_quote($file) . "$/i", $_FILES['file']['name'])) {  
									$error .= $this->TP_NO_EXECUTABLE;

									break;
							}

							if(empty($error))
								@move_uploaded_file($_FILES['file']['tmp_name'], $curdir . '/' . $_FILES['file']['name']);
            }
          } elseif($_FILES['file']['error'] != UPLOAD_ERR_OK)
            $error = "$this->TP_ERROR_UPLOADING ($_FILES[file][error])";

          if(isset($_GET['del'])) { // delete file/directory
            $file = $this->cleanInput($_GET['del']);

						$ret = is_dir($file) ? @rmdir($file) : @unlink($file);
          }
        } elseif($_SERVER['REQUEST_METHOD'] == 'POST')
          $error = $TE_WRONG_PASSWORD;

        // list of files
        if($opening_dir = @opendir($curdir)) {
          $CON .= '<h2>' . $this->TP_DIRECTORY . " " . $curdir . '</h2><table id=\"upload-list\" style="float : left;width : 500px;"><col span="2" style="color : red;" /><col /><col style="text-align : right;" /><col style="text-align : center;" /><tr><th>' . $this->TP_FILE_NAME . '</th><th>' . $this->TP_FILE_TYPE . '</th><th>' . $this->TP_FILE_SIZE . '</th><th>' . $this->TP_DELETE . '</th></tr>';

          $files = array();

          while($filename = @readdir($opening_dir)) // do not add link to parent of data_dir
            if($filename != '.' && ($filename != '..' || $curdir != trim($this->datadir, '/')))
              $files[] = array($filename, is_dir($curdir . "/" . $filename));

          
          function cmp_files($a, $b) // sort directories first, then files.
          {
            if($a[1] == $b[1])
              return strcmp($a[0], $b[0]) < 0 ? -1 : 1;
            else
              return $b[1];
          }

					if($files)
            usort($files, "cmp_files");

          foreach($files as $file) {
            if($file[0] == '..')
              $path = substr($curdir, 0, strrpos($curdir, '/'));
            else
              $path = $curdir . '/' . $file[0];

            $CON .= "<tr>";

            if(is_dir($path))
              $CON = $CON . '<td><a href="./?action=' . $action . '&curdir=' . urlencode($path) . '">[' . $file[0] . ']</a></td><td>' . $this->TP_DIRECTORY . '</td><td>-</td>';
            else
              $CON = $CON . '<td><a href="' . $path . '">' . $file[0] . '</a></td><td>' . $this->TP_FILE . '</td><td>'.@filesize($path) . '</td>';

            if((authentified()) && ($file[0] != '..'))
              $CON .= '<td><a title="delete" href="./?action=upload&del=' . urlencode($path) . "&curdir=" . urlencode($curdir) . '">&times;</a></td>';

            $CON .= "</tr>\n";
          }

          $CON .= "</table>";
        }

        $CON .= '
<div id=\"upload-form\" style="float:right;">
  <form method="post" action="./?action=' . $action . '" enctype= "multipart/form-data">
  <input type="hidden" name="curdir" value="' . $curdir . '" />
    <table>
';
        $CON .= "<tr><td>$this->TP_FILE:</td><td><input type=\"file\" name=\"file\" /></td></tr>\n";
        $CON .= "<tr><td>$this->TP_CREATE_DIRECTORY:</td><td><input type=\"text\" name=\"dir2create\" /></td></tr>\n";

        if(!authentified())
          $CON .= "<tr><td>$T_PASSWORD:</td><td><input type=\"password\" name=\"sc\" /></td></tr>\n";

        $CON .= "<tr><td>&nbsp;</td><td><input type=\"submit\" value=\"$this->TP_UPLOAD\" accesskey=\"s\" /></td></tr>
    </table>
</form>
</div>\n";
        $CON .= "<br style=\"clear:both;\" /><br /><br /><div>$this->TP_MAXIMUM_SIZE_IS " . ini_get('upload_max_filesize') . "</div>";
      } else
        $CON = "<div class=\"error\">$this->TP_NO_DATA_DIR ($this->datadir).</div>";

      return true;
    }
    
    return false;
  }
  
  function template()
  {				
  	global $html;
	  
		$html = preg_replace("/\{([^}]* )?plugin:UPLOAD( [^}]*)?\}/U", "$1<a href=\"?action=upload\">Upload</a>$2", $html);
	}
  
  // Localization strings

  public $cs_strings = array(
		array("TP_FILE_UPLOAD", "Upload souborů"),
		array("TP_FILE_NAME", "Jméno souboru"),
		array("TP_FILE_TYPE", "Typ souboru"),
		array("TP_FILE_SIZE", "Velikost"),
		array("TP_DELETE", "Smazat"),
		array("TP_ERROR_UPLOADING", "Nastala chyba při uploadu souboru"),
		array("TP_FILE", "Soubor"),
		array("TP_DIRECTORY", "Adresář"),
		array("TP_CREATE_DIRECTORY", "Vytvořit adresář"),
		array("TP_UPLOAD", "Nahrát"),
		array("TP_MAXIMUM_SIZE_IS", "Maximální velikost souboru je"),
		array("TP_NO_DATA_DIR", "Adresář pro data neexistuje"),
		array("TP_NO_EXECUTABLE", "Uploadování spustitelných souborů je zakázané.")
	);


  public $en_strings = array(
		array("TP_FILE_UPLOAD", "File upload"),
		array("TP_FILE_NAME", "File name"),
		array("TP_FILE_TYPE", "Type"),
		array("TP_FILE_SIZE", "Size"),
		array("TP_DELETE", "Delete"),
		array("TP_ERROR_UPLOADING", "Error ocurred during uploading file"),
		array("TP_FILE", "File"),
		array("TP_DIRECTORY", "Directory"),
		array("TP_CREATE_DIRECTORY", "Create directory"),
		array("TP_UPLOAD", "Upload"),
		array("TP_MAXIMUM_SIZE_IS", "Maximum size of uploaded file is"),
		array("TP_NO_DATA_DIR", "Data directory doesn't exist"),
		array("TP_NO_EXECUTABLE", "Upload of executable files is not permitted.")
	);

  function localize()
  {
    global $LANG;

    foreach($this->en_strings as $str)
      $this->$str[0] = $str[1];

    if($LANG != "en" && isset(${$LANG . "_strings"}))
      foreach($this->{$LANG . "_strings"} as $str)
        $this->$str[0] = $str[1];
  }
}
?>
